'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getCollection = exports.dropCollection = exports.createCollection = undefined;

var createCollection = exports.createCollection = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repository, name) {
        var client, metaCollection, collection;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        client = repository.client, metaCollection = repository.metaCollection;
                        _context.next = 3;
                        return (0, _redisApi.exists)(client, name);

                    case 3:
                        if (!_context.sent) {
                            _context.next = 5;
                            break;
                        }

                        throw new Error('Collection ' + name + ' is exist');

                    case 5:
                        _context.next = 7;
                        return metaCollection.exists(name);

                    case 7:
                        if (!_context.sent) {
                            _context.next = 9;
                            break;
                        }

                        throw new Error('Collection ' + name + ' had already been created in current database, ' + 'but not with resolve read model adapter and has no required meta information');

                    case 9:
                        _context.next = 11;
                        return metaCollection.create(name, {
                            lastTimestamp: 0,
                            indexes: []
                        });

                    case 11:
                        _context.next = 13;
                        return getCollection(repository, name);

                    case 13:
                        collection = _context.sent;
                        _context.next = 16;
                        return collection.ensureIndex({ fieldName: '_id', fieldType: 'number' });

                    case 16:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function createCollection(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var dropCollection = exports.dropCollection = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref3, name) {
        var client = _ref3.client,
            metaCollection = _ref3.metaCollection;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return (0, _redisApi.del)(client, name);

                    case 2:
                        _context2.next = 4;
                        return metaCollection.del(name);

                    case 4:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function dropCollection(_x3, _x4) {
        return _ref2.apply(this, arguments);
    };
}();

var getCollection = exports.getCollection = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(repository, name) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        return _context3.abrupt('return', (0, _collection2.default)(repository, name));

                    case 1:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function getCollection(_x5, _x6) {
        return _ref4.apply(this, arguments);
    };
}();

var _collection = require('./collection');

var _collection2 = _interopRequireDefault(_collection);

var _redisApi = require('./redisApi');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var adapter = function adapter(repository) {
    return Object.freeze({
        createCollection: createCollection.bind(null, repository),
        dropCollection: dropCollection.bind(null, repository),
        collection: _collection2.default.bind(null, repository)
    });
};

exports.default = adapter;