'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = buildProjection;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function buildProjection(repository, inputProjection) {
    var _this = this;

    repository.initHandler = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, _this);
    }));

    return Object.keys(inputProjection).reduce(function (projection, eventType) {
        if (eventType === 'Init' && typeof inputProjection[eventType] === 'function') {
            repository.initHandler = inputProjection[eventType];
            return projection;
        }

        projection[eventType] = function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(event, onDemandOptions) {
                var writeInterface, handler;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.next = 2;
                                return repository.initDonePromise;

                            case 2:
                                writeInterface = repository.writeInterface;
                                handler = inputProjection[eventType];
                                _context2.prev = 4;
                                _context2.next = 7;
                                return handler(writeInterface, event);

                            case 7:
                                _context2.next = 12;
                                break;

                            case 9:
                                _context2.prev = 9;
                                _context2.t0 = _context2['catch'](4);

                                repository.internalError = _context2.t0;

                            case 12:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, _this, [[4, 9]]);
            }));

            return function (_x, _x2) {
                return _ref2.apply(this, arguments);
            };
        }();
        return projection;
    }, {});
}
module.exports = exports['default'];