'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = createRedisAdapter;

require('regenerator-runtime/runtime');

var _redis = require('redis');

var _redis2 = _interopRequireDefault(_redis);

var _build_projection = require('./build_projection');

var _build_projection2 = _interopRequireDefault(_build_projection);

var _init = require('./init');

var _init2 = _interopRequireDefault(_init);

var _reset = require('./reset');

var _reset2 = _interopRequireDefault(_reset);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var DEFAULT_META_COLLECTION_NAME = '__ResolveMetaCollection__';
var DEFAULT_AUTOINC_META_COLLECTION_NAME = '__ResolveMetaCollectionAutoinc__';

function createRedisAdapter(options, metaCollectionName, autoincMetaCollectionName) {
    var _this = this;

    var repository = Object.create(null);

    repository.metaCollectionName = metaCollectionName && metaCollectionName.constructor === String ? metaCollectionName : DEFAULT_META_COLLECTION_NAME;

    repository.autoincMetaCollectionName = autoincMetaCollectionName && autoincMetaCollectionName.constructor === String ? autoincMetaCollectionName : DEFAULT_AUTOINC_META_COLLECTION_NAME;

    repository.connectDatabase = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            return _context.abrupt('return', _redis2.default.createClient(options instanceof Object ? options : {}));

                        case 1:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this);
        }));

        return function (_x) {
            return _ref.apply(this, arguments);
        };
    }();

    return Object.create(null, {
        buildProjection: {
            value: _build_projection2.default.bind(null, repository)
        },
        init: {
            value: _init2.default.bind(null, repository)
        },
        reset: {
            value: _reset2.default.bind(null, repository)
        }
    });
}
module.exports = exports['default'];