'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _redisApi = require('./redisApi');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var DEFAULT_META = { lastTimestamp: 0, indexes: {} };

var create = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2, collectionName) {
        var client = _ref2.client,
            metaCollectionName = _ref2.metaCollectionName,
            autoincMetaCollectionName = _ref2.autoincMetaCollectionName;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return (0, _redisApi.hset)(client, metaCollectionName, collectionName, DEFAULT_META);

                    case 2:
                        _context.next = 4;
                        return (0, _redisApi.hset)(client, autoincMetaCollectionName, collectionName, 0);

                    case 4:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function create(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var del = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref4, collectionName) {
        var client = _ref4.client,
            metaCollectionName = _ref4.metaCollectionName,
            autoincMetaCollectionName = _ref4.autoincMetaCollectionName;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return (0, _redisApi.hdel)(client, metaCollectionName, collectionName);

                    case 2:
                        _context2.next = 4;
                        return (0, _redisApi.hdel)(client, autoincMetaCollectionName, collectionName);

                    case 4:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, undefined);
    }));

    return function del(_x3, _x4) {
        return _ref3.apply(this, arguments);
    };
}();

var exists = function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref6, collectionName) {
        var client = _ref6.client,
            metaCollectionName = _ref6.metaCollectionName;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return (0, _redisApi.hexists)(client, metaCollectionName, collectionName);

                    case 2:
                        return _context3.abrupt('return', _context3.sent);

                    case 3:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, undefined);
    }));

    return function exists(_x5, _x6) {
        return _ref5.apply(this, arguments);
    };
}();

var get = function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref8, collectionName) {
        var client = _ref8.client,
            metaCollectionName = _ref8.metaCollectionName;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return (0, _redisApi.hget)(client, metaCollectionName, collectionName);

                    case 2:
                        return _context4.abrupt('return', _context4.sent);

                    case 3:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, undefined);
    }));

    return function get(_x7, _x8) {
        return _ref7.apply(this, arguments);
    };
}();

var set = function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref10, collectionName, meta) {
        var client = _ref10.client,
            metaCollectionName = _ref10.metaCollectionName;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.next = 2;
                        return (0, _redisApi.hset)(client, metaCollectionName, collectionName, meta);

                    case 2:
                        return _context5.abrupt('return', _context5.sent);

                    case 3:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, undefined);
    }));

    return function set(_x9, _x10, _x11) {
        return _ref9.apply(this, arguments);
    };
}();

var getNextId = function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(_ref12, collectionName) {
        var client = _ref12.client,
            autoincMetaCollectionName = _ref12.autoincMetaCollectionName;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.t0 = parseInt;
                        _context6.next = 3;
                        return (0, _redisApi.hincrby)(client, autoincMetaCollectionName, collectionName, 1);

                    case 3:
                        _context6.t1 = _context6.sent;
                        return _context6.abrupt('return', (0, _context6.t0)(_context6.t1, 10));

                    case 5:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee6, undefined);
    }));

    return function getNextId(_x12, _x13) {
        return _ref11.apply(this, arguments);
    };
}();

var getFindIndexName = function getFindIndexName(collectionName, fieldName) {
    return collectionName + '__find_index__' + fieldName;
};

var getSortIndexName = function getSortIndexName(collectionName, fieldName) {
    return collectionName + '__sort_index__' + fieldName;
};

var ensureIndex = function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(repository, collectionName, _ref14) {
        var fieldName = _ref14.fieldName,
            fieldType = _ref14.fieldType,
            order = _ref14.order;
        var meta;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        _context7.next = 2;
                        return get(repository, collectionName);

                    case 2:
                        meta = _context7.sent;

                        if (!meta.indexes[fieldName]) {
                            _context7.next = 5;
                            break;
                        }

                        throw new Error('Can\'t \'ensureIndex\': \'' + fieldName + '\' is exists');

                    case 5:

                        meta.indexes[fieldName] = {
                            fieldName: fieldName,
                            fieldType: fieldType,
                            order: order
                        };

                        _context7.next = 8;
                        return set(repository, collectionName, meta);

                    case 8:
                    case 'end':
                        return _context7.stop();
                }
            }
        }, _callee7, undefined);
    }));

    return function ensureIndex(_x14, _x15, _x16) {
        return _ref13.apply(this, arguments);
    };
}();

var removeIndex = function () {
    var _ref15 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(repository, collectionName, fieldName) {
        var meta;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
                switch (_context8.prev = _context8.next) {
                    case 0:
                        _context8.next = 2;
                        return get(repository, collectionName);

                    case 2:
                        meta = _context8.sent;

                        if (meta.indexes[fieldName]) {
                            _context8.next = 5;
                            break;
                        }

                        throw new Error('Can\'t \'removeIndex\': \'' + fieldName + '\' is not exists');

                    case 5:
                        delete meta.indexes[fieldName];

                        _context8.next = 8;
                        return set(repository, collectionName, meta);

                    case 8:
                    case 'end':
                        return _context8.stop();
                }
            }
        }, _callee8, undefined);
    }));

    return function removeIndex(_x17, _x18, _x19) {
        return _ref15.apply(this, arguments);
    };
}();

var getIndexes = function () {
    var _ref16 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(_ref17, collectionName) {
        var client = _ref17.client,
            metaCollectionName = _ref17.metaCollectionName;
        var meta;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
            while (1) {
                switch (_context9.prev = _context9.next) {
                    case 0:
                        _context9.next = 2;
                        return (0, _redisApi.hget)(client, metaCollectionName, collectionName);

                    case 2:
                        meta = _context9.sent;
                        return _context9.abrupt('return', !meta ? DEFAULT_META.indexes : meta.indexes);

                    case 4:
                    case 'end':
                        return _context9.stop();
                }
            }
        }, _callee9, undefined);
    }));

    return function getIndexes(_x20, _x21) {
        return _ref16.apply(this, arguments);
    };
}();

exports.default = function (repository) {
    return Object.freeze({
        create: create.bind(null, repository),
        del: del.bind(null, repository),
        exists: exists.bind(null, repository),
        get: get.bind(null, repository),
        getFindIndexName: getFindIndexName,
        getSortIndexName: getSortIndexName,
        getNextId: getNextId.bind(null, repository),
        ensureIndex: ensureIndex.bind(null, repository),
        removeIndex: removeIndex.bind(null, repository),
        getIndexes: getIndexes.bind(null, repository)
    });
};

module.exports = exports['default'];