'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var serializeData = function serializeData(data) {
    return JSON.stringify(data);
};

// const unserializeData = data => JSON.parse(data);

var safeParse = function safeParse(str) {
    try {
        return JSON.parse(str);
    } catch (e) {
        return str;
    }
};

var invokeCommand = function invokeCommand(client, command, name) {
    for (var _len = arguments.length, args = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        args[_key - 3] = arguments[_key];
    }

    return new Promise(function (resolve, reject) {
        var params = [name].concat(args, [function (err, data) {
            if (err) {
                return reject(err);
            }
            return resolve(Array.isArray(data) ? data.map(safeParse) : safeParse(data));
        }]);
        client[command].apply(client, _toConsumableArray(params));
    });
};

var hdel = exports.hdel = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(client, collectionName) {
        for (var _len2 = arguments.length, fields = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
            fields[_key2 - 2] = arguments[_key2];
        }

        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return invokeCommand.apply(undefined, [client, 'HDEL', collectionName].concat(fields));

                    case 2:
                        return _context.abrupt('return', _context.sent);

                    case 3:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function hdel(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var hexists = exports.hexists = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(client, collectionName, field) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return invokeCommand(client, 'HEXISTS', collectionName, field);

                    case 2:
                        return _context2.abrupt('return', _context2.sent);

                    case 3:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, undefined);
    }));

    return function hexists(_x3, _x4, _x5) {
        return _ref2.apply(this, arguments);
    };
}();

var hget = exports.hget = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(client, collectionName, field) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return invokeCommand(client, 'HGET', collectionName, field);

                    case 2:
                        return _context3.abrupt('return', _context3.sent);

                    case 3:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, undefined);
    }));

    return function hget(_x6, _x7, _x8) {
        return _ref3.apply(this, arguments);
    };
}();

var hkeys = exports.hkeys = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(client, collectionName) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return invokeCommand(client, 'HKEYS', collectionName);

                    case 2:
                        return _context4.abrupt('return', _context4.sent);

                    case 3:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, undefined);
    }));

    return function hkeys(_x9, _x10) {
        return _ref4.apply(this, arguments);
    };
}();

var hlen = exports.hlen = function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(client, collectionName) {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.next = 2;
                        return invokeCommand(client, 'HLEN', collectionName);

                    case 2:
                        return _context5.abrupt('return', _context5.sent);

                    case 3:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, undefined);
    }));

    return function hlen(_x11, _x12) {
        return _ref5.apply(this, arguments);
    };
}();

var hset = exports.hset = function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(client, collectionName, field, values) {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.next = 2;
                        return invokeCommand(client, 'HSET', collectionName, field, serializeData(values));

                    case 2:
                        return _context6.abrupt('return', _context6.sent);

                    case 3:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee6, undefined);
    }));

    return function hset(_x13, _x14, _x15, _x16) {
        return _ref6.apply(this, arguments);
    };
}();

var hvals = exports.hvals = function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(client, collectionName) {
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        _context7.next = 2;
                        return invokeCommand(client, 'HVALS', collectionName);

                    case 2:
                        return _context7.abrupt('return', _context7.sent);

                    case 3:
                    case 'end':
                        return _context7.stop();
                }
            }
        }, _callee7, undefined);
    }));

    return function hvals(_x17, _x18) {
        return _ref7.apply(this, arguments);
    };
}();

var hincrby = exports.hincrby = function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(client, key, field, increment) {
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
                switch (_context8.prev = _context8.next) {
                    case 0:
                        _context8.next = 2;
                        return invokeCommand(client, 'HINCRBY', key, field, increment);

                    case 2:
                        return _context8.abrupt('return', _context8.sent);

                    case 3:
                    case 'end':
                        return _context8.stop();
                }
            }
        }, _callee8, undefined);
    }));

    return function hincrby(_x19, _x20, _x21, _x22) {
        return _ref8.apply(this, arguments);
    };
}();

var del = exports.del = function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(client) {
        for (var _len3 = arguments.length, keys = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
            keys[_key3 - 1] = arguments[_key3];
        }

        return regeneratorRuntime.wrap(function _callee9$(_context9) {
            while (1) {
                switch (_context9.prev = _context9.next) {
                    case 0:
                        _context9.next = 2;
                        return invokeCommand.apply(undefined, [client, 'DEL'].concat(keys));

                    case 2:
                    case 'end':
                        return _context9.stop();
                }
            }
        }, _callee9, undefined);
    }));

    return function del(_x23) {
        return _ref9.apply(this, arguments);
    };
}();

var exists = exports.exists = function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(client, key) {
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
            while (1) {
                switch (_context10.prev = _context10.next) {
                    case 0:
                        _context10.next = 2;
                        return invokeCommand(client, 'EXISTS', key);

                    case 2:
                        return _context10.abrupt('return', _context10.sent);

                    case 3:
                    case 'end':
                        return _context10.stop();
                }
            }
        }, _callee10, undefined);
    }));

    return function exists(_x24, _x25) {
        return _ref10.apply(this, arguments);
    };
}();

var type = exports.type = function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(client, key) {
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
            while (1) {
                switch (_context11.prev = _context11.next) {
                    case 0:
                        _context11.next = 2;
                        return invokeCommand(client, 'TYPE', key);

                    case 2:
                        return _context11.abrupt('return', _context11.sent);

                    case 3:
                    case 'end':
                        return _context11.stop();
                }
            }
        }, _callee11, undefined);
    }));

    return function type(_x26, _x27) {
        return _ref11.apply(this, arguments);
    };
}();

var zadd = exports.zadd = function () {
    var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(client, key, score, member) {
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
            while (1) {
                switch (_context12.prev = _context12.next) {
                    case 0:
                        _context12.next = 2;
                        return invokeCommand(client, 'ZADD', key, score, member);

                    case 2:
                        return _context12.abrupt('return', _context12.sent);

                    case 3:
                    case 'end':
                        return _context12.stop();
                }
            }
        }, _callee12, undefined);
    }));

    return function zadd(_x28, _x29, _x30, _x31) {
        return _ref12.apply(this, arguments);
    };
}();

var zaddMulti = exports.zaddMulti = function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(client, args) {
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
            while (1) {
                switch (_context13.prev = _context13.next) {
                    case 0:
                        _context13.next = 2;
                        return invokeCommand(client, 'ZADD', args);

                    case 2:
                        return _context13.abrupt('return', _context13.sent);

                    case 3:
                    case 'end':
                        return _context13.stop();
                }
            }
        }, _callee13, undefined);
    }));

    return function zaddMulti(_x32, _x33) {
        return _ref13.apply(this, arguments);
    };
}();

var zrangebyscore = exports.zrangebyscore = function () {
    var _ref14 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(client, key, min, max, offset, count) {
        return regeneratorRuntime.wrap(function _callee14$(_context14) {
            while (1) {
                switch (_context14.prev = _context14.next) {
                    case 0:
                        if (!(offset === undefined && count === undefined)) {
                            _context14.next = 6;
                            break;
                        }

                        _context14.next = 3;
                        return invokeCommand(client, 'ZRANGEBYSCORE', key, min, max);

                    case 3:
                        return _context14.abrupt('return', _context14.sent);

                    case 6:
                        if (!(count === undefined)) {
                            _context14.next = 12;
                            break;
                        }

                        _context14.next = 9;
                        return invokeCommand(client, 'ZRANGEBYSCORE', key, min, max, offset);

                    case 9:
                        return _context14.abrupt('return', _context14.sent);

                    case 12:
                        _context14.next = 14;
                        return invokeCommand(client, 'ZRANGEBYSCORE', key, min, max, offset, count);

                    case 14:
                        return _context14.abrupt('return', _context14.sent);

                    case 15:
                    case 'end':
                        return _context14.stop();
                }
            }
        }, _callee14, undefined);
    }));

    return function zrangebyscore(_x34, _x35, _x36, _x37, _x38, _x39) {
        return _ref14.apply(this, arguments);
    };
}();

var zrangebylex = exports.zrangebylex = function () {
    var _ref15 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(client, key, min, max, offset, count) {
        return regeneratorRuntime.wrap(function _callee15$(_context15) {
            while (1) {
                switch (_context15.prev = _context15.next) {
                    case 0:
                        if (!(offset === undefined && count === undefined)) {
                            _context15.next = 6;
                            break;
                        }

                        _context15.next = 3;
                        return invokeCommand(client, 'ZRANGEBYLEX', key, min, max);

                    case 3:
                        return _context15.abrupt('return', _context15.sent);

                    case 6:
                        if (!(count === undefined)) {
                            _context15.next = 12;
                            break;
                        }

                        _context15.next = 9;
                        return invokeCommand(client, 'ZRANGEBYLEX', key, min, max, offset);

                    case 9:
                        return _context15.abrupt('return', _context15.sent);

                    case 12:
                        _context15.next = 14;
                        return invokeCommand(client, 'ZRANGEBYLEX', key, min, max, offset, count);

                    case 14:
                        return _context15.abrupt('return', _context15.sent);

                    case 15:
                    case 'end':
                        return _context15.stop();
                }
            }
        }, _callee15, undefined);
    }));

    return function zrangebylex(_x40, _x41, _x42, _x43, _x44, _x45) {
        return _ref15.apply(this, arguments);
    };
}();

var zrem = exports.zrem = function () {
    var _ref16 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(client, key, member) {
        return regeneratorRuntime.wrap(function _callee16$(_context16) {
            while (1) {
                switch (_context16.prev = _context16.next) {
                    case 0:
                        _context16.next = 2;
                        return invokeCommand(client, 'ZREM', key, member);

                    case 2:
                        return _context16.abrupt('return', _context16.sent);

                    case 3:
                    case 'end':
                        return _context16.stop();
                }
            }
        }, _callee16, undefined);
    }));

    return function zrem(_x46, _x47, _x48) {
        return _ref16.apply(this, arguments);
    };
}();

var zinterstore = exports.zinterstore = function () {
    var _ref17 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(client, destination, keycount, keys) {
        return regeneratorRuntime.wrap(function _callee17$(_context17) {
            while (1) {
                switch (_context17.prev = _context17.next) {
                    case 0:
                        _context17.next = 2;
                        return invokeCommand.apply(undefined, [client, 'ZINTERSTORE', destination, keycount].concat(_toConsumableArray(keys)));

                    case 2:
                        return _context17.abrupt('return', _context17.sent);

                    case 3:
                    case 'end':
                        return _context17.stop();
                }
            }
        }, _callee17, undefined);
    }));

    return function zinterstore(_x49, _x50, _x51, _x52) {
        return _ref17.apply(this, arguments);
    };
}();

var zrange = exports.zrange = function () {
    var _ref18 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(client, key) {
        var start = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
        var stop = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : -1;
        return regeneratorRuntime.wrap(function _callee18$(_context18) {
            while (1) {
                switch (_context18.prev = _context18.next) {
                    case 0:
                        _context18.next = 2;
                        return invokeCommand(client, 'ZRANGE', key, start, stop);

                    case 2:
                        return _context18.abrupt('return', _context18.sent);

                    case 3:
                    case 'end':
                        return _context18.stop();
                }
            }
        }, _callee18, undefined);
    }));

    return function zrange(_x53, _x54) {
        return _ref18.apply(this, arguments);
    };
}();

var zrevrange = exports.zrevrange = function () {
    var _ref19 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(client, key) {
        var start = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
        var stop = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : -1;
        return regeneratorRuntime.wrap(function _callee19$(_context19) {
            while (1) {
                switch (_context19.prev = _context19.next) {
                    case 0:
                        _context19.next = 2;
                        return invokeCommand(client, 'ZREVRANGE', key, start, stop);

                    case 2:
                        return _context19.abrupt('return', _context19.sent);

                    case 3:
                    case 'end':
                        return _context19.stop();
                }
            }
        }, _callee19, undefined);
    }));

    return function zrevrange(_x57, _x58) {
        return _ref19.apply(this, arguments);
    };
}();

var expire = exports.expire = function () {
    var _ref20 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(client, key, seconds) {
        return regeneratorRuntime.wrap(function _callee20$(_context20) {
            while (1) {
                switch (_context20.prev = _context20.next) {
                    case 0:
                        _context20.next = 2;
                        return invokeCommand(client, 'EXPIRE', key, seconds);

                    case 2:
                        return _context20.abrupt('return', _context20.sent);

                    case 3:
                    case 'end':
                        return _context20.stop();
                }
            }
        }, _callee20, undefined);
    }));

    return function expire(_x61, _x62, _x63) {
        return _ref20.apply(this, arguments);
    };
}();

var zremrangebylex = exports.zremrangebylex = function () {
    var _ref21 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21(client, key, min, max) {
        return regeneratorRuntime.wrap(function _callee21$(_context21) {
            while (1) {
                switch (_context21.prev = _context21.next) {
                    case 0:
                        _context21.next = 2;
                        return invokeCommand(client, 'ZREMRANGEBYLEX', key, min, max);

                    case 2:
                        return _context21.abrupt('return', _context21.sent);

                    case 3:
                    case 'end':
                        return _context21.stop();
                }
            }
        }, _callee21, undefined);
    }));

    return function zremrangebylex(_x64, _x65, _x66, _x67) {
        return _ref21.apply(this, arguments);
    };
}();